<!doctype html>
<!--
    Copyright (c) 2010, 2025 Contributors to the Eclipse Foundation

    See the NOTICE file(s) distributed with this work for additional
    information regarding copyright ownership.

    This program and the accompanying materials are made available under the terms
    of the MIT License which is available at https://opensource.org/licenses/MIT

    SPDX-License-Identifier: MIT
-->
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Module 1.3 | SBE Course</title>
        <link rel="icon" type="image/png" href="../sbe-course-favicon.png"/>

        <!-- Bootstrap. -->
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/css/bootstrap.min.css" crossorigin="anonymous">
        <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.6.0/font/bootstrap-icons.css" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.1/dist/js/bootstrap.bundle.min.js" crossorigin="anonymous"></script>

        <!-- Website styling. -->
        <link rel="stylesheet" href="../../assets/eclipse-escet.css">
        <link rel="stylesheet" href="../../assets/eclipse-escet-sbe-course.css">

        <!-- Version selector. -->
        <script src="../../assets/eclipse-escet.js"></script>

        <!-- Code block syntax highlighting. -->
        <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css">
        <script src="../../assets/highlight.min.js"></script>
        <script src="../../assets/languages/cif.min.js"></script>
        <script src="../../assets/languages/tooldef.min.js"></script>

        <!-- Quiz. -->
        <link rel="stylesheet" href="../assets/quiz.css">
        <script src="../assets/quiz.js"></script>

        <!-- SBE course. -->
        <link rel="stylesheet" href="../assets/course.css">
        <script src="../assets/course.js"></script>
    </head>

    <body class="escet-dark">

        <!-- Top navigation bar -->
        <nav class="navbar navbar-expand-lg navbar-dark escet-bg">
            <div class="container-fluid">
                <a class="navbar-brand d-lg-none">SBE Course</a>
                <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <ul class="navbar-nav me-auto mb-0 mb-lg-0">
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle escet-brand px-0" href="#" id="navbarDropdown" role="button" data-bs-toggle="dropdown" aria-expanded="false">Eclipse ESCET™ / SBE Course</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown">
                                <li><a class="dropdown-item" href="../.."><img src="../../eclipse-escet-favicon.png" class="pe-2"> Eclipse ESCET / Project</a></li>
                                <li><a class="dropdown-item" href=".."><img src="../sbe-course-favicon.png" class="pe-2"> Eclipse ESCET / SBE Course</a></li>
                                <li><a class="dropdown-item" href="../../cif"><img src="../../cif/cif-favicon.png" class="pe-2"> Eclipse ESCET / CIF</a></li>
                                <li><a class="dropdown-item" href="../../chi"><img src="../../chi/chi-favicon.png" class="pe-2"> Eclipse ESCET / Chi</a></li>
                                <li><a class="dropdown-item" href="../../tooldef"><img src="../../tooldef/tooldef-favicon.png" class="pe-2"> Eclipse ESCET / ToolDef</a></li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a class="nav-link" href="../" aria-expanded="false">Home</a>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle active" aria-current="page" href="#" id="navbarDropdown1" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 1</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown1">
                                <li><a class="dropdown-item" href="./">Module 1: Supervisory control of discrete event systems</a></li>
                                <li><a class="dropdown-item" href="supervisory-control.html">Module 1.1: Supervisory control</a></li>
                                <li><a class="dropdown-item" href="discrete-event-systems.html">Module 1.2: Discrete event systems</a></li>
                                <li><a class="dropdown-item active" aria-current="page" href="modeling-discrete-event-systems.html">Module 1.3: Modeling discrete event systems</a></li>
                                <li><a class="dropdown-item" href="get-started-with-cif.html">Module 1.4: Get started with CIF</a></li>
                                <li><a class="dropdown-item" href="exercises.html">Module 1.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="introduction-to-the-water-lock-case.html">Module 1.6: Introduction to the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown2" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 2</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown2">
                                <li><a class="dropdown-item" href="../module2">Module 2: Working with automata</a></li>
                                <li><a class="dropdown-item" href="../module2/reachability-deadlock-blocking-livelock.html">Module 2.1: Reachability, deadlock, blocking and livelock</a></li>
                                <li><a class="dropdown-item" href="../module2/non-deterministic-automata.html">Module 2.2: Non-deterministic automata</a></li>
                                <li><a class="dropdown-item" href="../module2/synchronizing-automata.html">Module 2.3: Synchronizing automata</a></li>
                                <li><a class="dropdown-item" href="../module2/shared-variables.html">Module 2.4: Shared variables</a></li>
                                <li><a class="dropdown-item" href="../module2/computing-state-spaces.html">Module 2.5: Computing state spaces</a></li>
                                <li><a class="dropdown-item" href="../module2/cif-tools-view-analyze-models.html">Module 2.6: CIF tools to view and analyze models</a></li>
                                <li><a class="dropdown-item" href="../module2/constants-and-algebraic-variables.html">Module 2.7: Constants and algebraic variables</a></li>
                                <li><a class="dropdown-item" href="../module2/exercises.html">Module 2.8: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module2/more-detailed-models-water-lock-case.html">Module 2.9: More detailed models for the water lock case</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown3" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 3</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown3">
                                <li><a class="dropdown-item" href="../module3">Module 3: Supervisory control and plant models</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-control-loop.html">Module 3.1: Supervisory control loop</a></li>
                                <li><a class="dropdown-item" href="../module3/synthesis-guarantees.html">Module 3.2: Synthesis guarantees</a></li>
                                <li><a class="dropdown-item" href="../module3/supervisory-controller-synthesis.html">Module 3.3: Supervisory controller synthesis</a></li>
                                <li><a class="dropdown-item" href="../module3/modeling-larger-systems.html">Module 3.4: Modeling larger systems</a></li>
                                <li><a class="dropdown-item" href="../module3/exercises.html">Module 3.5: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module3/water-lock-case-plant-models.html">Module 3.6: Water lock case plant models</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown4" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 4</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown4">
                                <li><a class="dropdown-item" href="../module4">Module 4: Modeling requirements and supervisor synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/user-specified-requirements.html">Module 4.1: User-specified requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/requirement-automata-and-invariants.html">Module 4.2: Requirements automata and invariants</a></li>
                                <li><a class="dropdown-item" href="../module4/synthesis-with-requirements.html">Module 4.3: Synthesis with requirements</a></li>
                                <li><a class="dropdown-item" href="../module4/modeling-for-synthesis.html">Module 4.4: Modeling for synthesis</a></li>
                                <li><a class="dropdown-item" href="../module4/performing-synthesis-with-cif.html">Module 4.5: Performing synthesis with CIF</a></li>
                                <li><a class="dropdown-item" href="../module4/introduction-to-svg-visualization.html">Module 4.6: Introduction to SVG visualization</a></li>
                                <li><a class="dropdown-item" href="../module4/exercises.html">Module 4.7: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module4/water-lock-case-requirements-and-supervisor.html">Module 4.8: Water lock case requirements and supervisor</a></li>
                            </ul>
                        </li>
                        <li class="nav-item dropdown">
                            <a class="nav-link dropdown-toggle" href="#" id="navbarDropdown5" role="button" data-bs-toggle="dropdown" aria-expanded="false">Module 5</a>
                            <ul class="dropdown-menu" aria-labelledby="navbarDropdown5">
                                <li><a class="dropdown-item" href="../module5">Module 5: Hybrid simulation models</a></li>
                                <li><a class="dropdown-item" href="../module5/timed-and-hybrid-models.html">Module 5.1: Timed and hybrid models</a></li>
                                <li><a class="dropdown-item" href="../module5/variable-time.html">Module 5.2: Variable 'time'</a></li>
                                <li><a class="dropdown-item" href="../module5/continuous-variables.html">Module 5.3: Continuous variables</a></li>
                                <li><a class="dropdown-item" href="../module5/urgency.html">Module 5.4: Urgency</a></li>
                                <li><a class="dropdown-item" href="../module5/tau-event.html">Module 5.5: The 'tau' event</a></li>
                                <li><a class="dropdown-item" href="../module5/exercises.html">Module 5.6: Exercises</a></li>
                                <li><a class="dropdown-item" href="../module5/water-lock-case-hybrid-model.html">Module 5.7: Water lock case hybrid model</a></li>
                                <li><a class="dropdown-item" href="../module5/course-conclusion.html">Module 5.8: Course conclusion</a></li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>

        <!-- Intro -->
        <div id="intro" class="position-relative p-3 text-center escet-bg escet-bg-opacity-125">
            <div class="clearfix mb-4 mb-md-0">
                <span class="float-end">
                    Version:
                    <div class="dropdown d-inline-block">
                        <a class="dropdown-toggle" href="#" role="button" id="versionDropdown" data-bs-toggle="dropdown" aria-expanded="false">@@ESCET-VERSION-ENDUSER@@</a>
                        <ul id="versions-dropdown" class="dropdown-menu dropdown-menu-end" aria-labelledby="versionDropdown" data-this-version="/@@ESCET-DEPLOY-FOLDER-NAME@@">
                            <li><h6 id="versions-previews" class="dropdown-header">Previews</h6></li>
                            <li><h6 id="versions-latest-releases" class="dropdown-header">Latest releases</h6></li>
                            <li><h6 class="dropdown-header">Other</h6></li>
                            <li><a class="dropdown-item" href="../../versions.html">All versions...</a></li>
                        </ul>
                    </div>
                    <a class="text-nowrap ms-3" href="../../release-notes.html">[release notes]</a>
                </span>
            </div>
        </div>

        <!-- Content -->
        <div class="px-4 pt-5">
            <div class="row justify-content-center">
                <div class="col-12 col-md-10 col-xl-8 col-xxl-6" id="content">

                    <h1>Module 1.3: Modeling discrete event systems</h1>
                    <p>
                        Discrete event systems have discrete states, with transitions between them, and the transitions are associated with events that may occur in the system.
                        If a plant (uncontrolled system) can be seen as such a discrete event system, it can be modeled using a discrete event model.
                        Discrete event models primarily consist of events, and of automata that have locations and edges.
                        The models may also contain variables, and edges of automata may contain guards and updates.
                        In this sub-module you learn more about these concepts, which are key in modeling discrete systems.
                    </p>

                    <h2 id="automata-locations-and-edges">Automata, locations and edges</h2>
                    <p>
                        Discrete event systems consist of multiple parts, called <em>components</em>, like a bridge deck and a motor.
                        Each component is typically modeled using a single <em>automaton</em>.
                        The various automata together form the model of a system.
                        Each state of a component is modeled as a <em>location</em> of the automaton, and each transition of a component is modeled as an <em>edge</em> of the automaton.
                        We thus distinguish a location from a state, and an edge from a transition (more on that later).
                    </p>
                    <p>
                        Consider again the example from the <a href="discrete-event-systems.html">previous sub-module</a>, of a bridge with a bridge deck and a traffic light.
                        Recall that the bridge deck has three states, as it can be open, partially open or closed.
                        We previously named these states as <code>deck_is_open</code>, <code>deck_is_partially_open</code> and <code>deck_is_closed</code>.
                        To transition between the states, we defined three events: <code>deck_has_opened</code>, <code>deck_has_become_partially_open</code> and <code>deck_has_closed</code>.
                        For the traffic light, assuming it is a simple traffic light, it could have two states: <code>light_signals_red</code> and <code>light_signals_green</code>.
                        To transition between the states, we could define two events: <code>turn_to_red</code> and <code>turn_to_green</code>.
                        Typically, each component has an initial state.
                        In this case, for instance, initially the bridge deck could be closed and the traffic light could signal green, such that cars can drive over the bridge.
                    </p>
                    <p>
                        If we model both components separately, we would use two automata.
                        We could name them <code>BridgeDeck</code> and <code>TrafficLight</code>.
                        The three states of the bridge could then be modeled as three locations, which could be named <code>Open</code>, <code>PartiallyOpen</code> and <code>Closed</code>.
                        Because the locations are part of the <code>BridgeDeck</code> automaton, there is no need to repeat <code>deck_is</code> part of the state names.
                        Locations represent the states that the automaton can be in, and therefore shorter and simpler names can be used, that indicate the differences between the states.
                        Similarly, for the <code>TrafficLight</code>, we could simply name the locations <code>Red</code> and <code>Green</code>.
                        The <code>Closed</code> location would then be the initial location of the <code>BridgeDeck</code> automaton, and the <code>Green</code> location would be the initial location of the <code>TrafficLight</code> automaton.
                    </p>
                    <p>
                        Components can transition from one state (the source state) to another (the target state).
                        In a model, for each transition of a component the corresponding automaton contains an edge.
                        The edge is labeled with an event, just as a transition is associated with an event as well.
                        Similar to how locations can be given simpler names within the context of the automaton to which they belong, so can events.
                        We could for instance name the events of the bridge deck <code>opened</code>, <code>partially_opened</code> and <code>closed</code>.
                        Similarly, we could name the events of the traffic light <code>to_red</code> and <code>to_green</code>.
                    </p>
                    <p>
                        Below, you can see a graphical representation of the two automata.
                        Each automaton is labeled with the automaton's name.
                        Each location of an automaton is represented as a circle (or ellipse) that contains the name of the location.
                        Each edge between locations is represented as a directed arrow from its source location's circle to its target location's circle, with the name of the event being shown close to the arrow.
                        Multiple edges between the same locations are graphically represented by a single arrow, which is labeled with multiple event names separated with commas.
                        This avoids cluttering the graphical representation with many arrows.
                        So, for two edges labeled with events <code>a</code> and <code>b</code>, between the same source and target locations, the single arrow would be labeled with <code>a</code>, <code>b</code>.
                        Initial locations are indicated by an incoming arrow.
                    </p>
                    <img src="images/automaton-bridge-deck-and-traffic-light.png">

                    <h2>System behavior model</h2>
                    <p>
                        The state of the entire system is a combination of the states of its components, as we <a href="discrete-event-systems.html#system-behavior">learned in the previous sub-module</a>.
                        We can model the state space of a system also as a single automaton, that represents all the possible behavior of the system.
                        For instance, for the system consisting of a bridge deck and a traffic light, there are six states: three states of the bridge deck combined in every possible way with the two states of the traffic light.
                        These six states are: <code>(deck_is_open, light_signals_red)</code>, <code>(deck_is_open, light_signals_green)</code>, <code>(deck_is_partially_open, light_signals_red)</code>, <code>(deck_is_partially_open, light_signals_green)</code>, <code>(deck_is_closed, light_signals_red)</code> and <code>(deck_is_closed, light_signals_green)</code>.
                        If we name the automaton <code>BridgeDeckAndTrafficLight</code>, we could simply name the states <code>ClosedGreen</code>, <code>PartiallyOpenGreen</code>, <code>OpenGreen</code>, <code>ClosedRed</code>, <code>PartiallyOpenRed</code> and <code>OpenRed</code>.
                        Location <code>ClosedGreen</code> is then the initial location.
                        The automaton that represents the state space of the uncontrolled system thus looks like this:
                    </p>
                    <img src="images/automaton-bridge-uncontrolled.png">
                    <p>
                        Now, let us manually derive a supervisory controller for this system.
                        The state space automaton represents all the behavior of the system, for both the bridge deck and the traffic light.
                        While all six states are physically possible, not all of them are safe for the users of the system.
                        For instance, in state <code>(deck_is_partially_open, light_signals_green)</code> a car may drive into the water if its driver is not paying attention.
                        For safety reasons, we must thus ensure that this state is never reached.
                        Therefore, a safety requirement of this system is that the traffic light may never signal green while the bridge is (partially) open.
                    </p>
                    <p>
                        One could argue that state <code>(deck_is_closed, light_signals_red)</code> is also not needed, as in that state cars are not allowed to drive over the bridge deck, while the bridge deck is closed.
                        From a practical point of view this does not seem like a very useful state, but it is needed for the safe operation of the system.
                        The operator should only be able to open the bridge while the traffic light signals red.
                        The traffic light should stay red while the bridge deck is opening or fully open.
                        Only once the bridge deck is fully closed again, may the traffic light signal green again, such that cars can safely pass over the bridge.
                        There is thus a brief moment, just after the bridge deck has fully closed, and just before the supervisory controller gives the traffic light the command to signal green, that the bridge deck is closed and the traffic light signals red.
                        Similarly, when the bridge deck is to be opened, the traffic light is first instructed to turn red, before the bridge deck is actually opened, such that again briefly the system is in the state where the bridge deck is closed and the traffic light signals red.
                        In general, in a discrete event system, only one event can happen at any time.
                        The next event could occur very quickly after the previous one, but there is thus always a state in between.
                    </p>
                    <p>
                        Below, the automaton representing the state space of the controlled system is shown.
                        It is a restricted version of the state space of the uncontrolled system.
                        Unsafe locations <code>PartiallyOpenGreen</code> and <code>OpenGreen</code> are removed, as are all edges to and from these locations.
                        There is thus no way to transition to the unsafe locations anymore, while all safe system behavior is preserved.
                    </p>
                    <img src="images/automaton-bridge-controlled.png">

                    <h2 id="variables-guards-and-updates">Variables, guards and updates</h2>
                    <p>
                        Modeling different states of a component as locations is not always convenient.
                        Consider for instance a water lock that can accommodate at most four ships.
                        When a fifth ship arrives, a traffic light needs to signal that the ship must wait to enter the water lock, as the water lock is full.
                        To be able to express such behavior, the number of ships in the water lock needs to be counted.
                        A counter can be modeled as an automaton, with for every possible number of ships a separate location.
                        In this case, with zero, one, two, three or four ships in the water lock, that would require five locations.
                        The counter automaton could for instance look like this:
                    </p>
                    <img src="images/automaton-counter-locations.png">
                    <p>
                        One can imagine that the automaton becomes bigger if more ships need to be counted.
                        And if the number of ships changes, the automaton needs to be adapted, by adding and removing not only locations, but also all the edges between the locations.
                        In such a case, a variable offers a good alternative for locations, making it easier to scale and adapt the counter.
                        We could for instance introduce a variable named <code>ship_count</code> that represents the number of ships in the water lock.
                        Whenever a ship enters the water lock, the counter is updated by increasing the variable by one.
                        Similarly, whenever a ship leaves the water lock, the counter is updated by decreasing the variable by one.
                    </p>
                    <p>
                        Edges can have <em>updates</em> that indicate which variables should be updated when the edge is taken, and what their new values should become.
                        The simplest form of an update is an <em>assignment</em> that changes the value of a single variable.
                        It has the form <code>v := e</code>, where <code>v</code> is the variable that is to be updated, and <code>e</code> is an expression that when computed produces the new value of the variable.
                        For instance, <code>ship_count := 2</code> is an assignment that assign value <code>2</code> as the new value of variable <code>ship_count</code>.
                        A bit more complicated is assignment <code>ship_count := ship_count + 1</code>.
                        It increases the value of variable <code>ship_count</code> by one: it takes the current value of variable <code>ship_count</code> and adds <code>1</code> to it, incrementing the value by one, and this incremented value is then assigned to variable <code>ship_count</code>.
                        Here variable <code>ship_count</code> occurs both the left and the right of the <code>:=</code>.
                        On the right, it indicates the current value of the variable, in the location from where edge starts.
                        On the left, it indicates the variable that is to be assigned, and that thus gets a new value in the location where the edge ends.
                        For our counter, we would have assignment <code>ship_count := ship_count + 1</code> when event <code>ship_enters</code> occurs, and assignment <code>ship_count := ship_count - 1</code> when event <code>ship_leaves</code> occurs.
                    </p>
                    <p>
                        A water lock can not have a negative number of ships in it.
                        We thus need to prevent the counter from being updated to negative values.
                        For this purpose, guards can be added to edges.
                        A <em>guard</em> indicates the conditions under which an edge can be taken: if the condition holds, then the edge can be taken, and if the condition does not hold, the edge can not be taken.
                        Conditions, such as guard conditions, are specified as <em>predicates</em> that can be evaluated, resulting in either <em>true</em> or <em>false</em>.
                        For instance, to prevent the counter from getting a negative value, we could add guard <code>ship_count &gt; 0</code> to edges for event <code>ship_leaves</code>.
                        Predicate <code>ship_count &gt; 0</code> evaluates to <code>true</code> if variable <code>ship_count</code> is larger than zero, and it evaluates to <code>false</code> if the variable is less than or equal to zero.
                        When the edge is taken, the value of the variable is still decreased by one.
                        But, the value of the variable always remains at least zero, since the edge can only be taken when the variable has a value larger than zero.
                        The guard thus disables the edge when the guard condition is not satisfied, for instance when variable <code>ship_count</code> has value zero.
                        Similarly, to count at most four ships in the water lock, guard <code>ship_count &lt; 4</code> can be added to edges for event <code>ship_enters</code>.
                        The value of the variable is then kept as such that it is at least zero and at most four.
                        In general, if an edge does not have an explicitly stated guard, the guard is implicitly <code>true</code>, a condition that always holds, meaning there is no additional restriction on when the edge can be taken.
                    </p>
                    <p>
                        Similar to how an automaton has an initial location, a variable has an initial value.
                        If initially there are no ships in the water lock, counter variable <code>ship_count</code> initially has value zero, which we indicate as <code>ship_count = 0</code>.
                    </p>
                    <p>
                        The alternative model of the counter, using a variable, guards and updates, could then look as follows.
                        The initial value of the variable is indicated on the incoming arrow of the initial location.
                        The guards and updates are shown close to the edges, with the guards being above the event name, and the updates being below it.
                        All edges now start and end in the same single location of the automaton.
                        Such edges, that start and end in the same location, are called <em>self loop</em> edges or simply <em>self loops</em>.
                    </p>
                    <img src="images/automaton-counter-variable.png">
                    <p>
                        This alternative counter automaton has the same five states as the previous counter model that used five locations.
                        In both cases, initially no ships are present in the water lock, and at most four ships can enter and be counted.
                        In an empty water lock, a ship may thus enter four times before the lock is full and the counter reaches its maximum value.
                        If ships leave, the counter decreases, but it never decreases beyond zero.
                        Both models thus have the same behavior, consisting of five states and eight transitions.
                        They are just modeled differently, using either multiple locations or a variable with multiple values.
                        The state space of the counter automaton with the variable, represented as an automaton, is exactly that of the counter automaton modeled with locations.
                    </p>
                    <p>
                        Locations and variables can thus be used interchangeably to represent possible states of a component.
                        As a modeler, you can choose whichever one is best suited for a particular situation.
                        And more complex automata could have multiple locations and multiple variables.
                        But an automaton always requires at least one location, while variables are optional.
                        A state of an automaton modeled with one or more locations and zero or more variables, then consists of the current location of the automaton and the current value of each of the automaton's variables.
                    </p>
                    <p>
                        The locations of an automaton are called locations rather than states, as also variables can represent possible states of a component.
                        Using different names for the concepts allows to keep them apart, and avoid confusion.
                        Similarly, edges and transitions are different.
                        The counter automaton with the variable has only two edges, while the state space of that automaton has eight transitions.
                        Each edge thus corresponds to four out of the eight transitions in the state space.
                    </p>
                    <p>
                        It should by now be clear why a counter can better be modeled by using a variable than by using multiple locations.
                        The number of ships to be counted can easily be adapted by changing value <code>4</code> in guard <code>ship_count &lt; 4</code>.
                        After all, it is much easier to change value <code>4</code> to <code>104</code> than it is to add a hundred locations and double the amount of edges.
                    </p>

                    <h2>Marked locations and states</h2>
                    <p>
                        Besides a location being an initial location, a location may also be a <em>marked</em> location.
                        By marking a location, you can indicate that you consider that location to be stable.
                        A sequence of events ending in a stable location can be interpreted as the completion of some tasks or operations.
                        Consider for instance the coffee machine from the <a href="discrete-event-systems.html#quiz">quiz</a> of the previous sub-module.
                        Initially the coffee machine is in state <code>Waiting</code>.
                        By event sequence <code>make_choice</code>, <code>finish_prepare</code>, <code>finish_coffee</code> and <code>remove_cup</code>, the coffee machine completes a full task to provide a user with a coffee.
                        It then returns back to stable state <code>Waiting</code>, where another user can again order a coffee.
                    </p>
                    <p>
                        An automaton should have at least one marked location, but may have multiple marked locations.
                        A typical situation is for an automaton's initial location to also be its only marked location.
                        For instance, components are often initially idle, then perform some task, and after performing the task they are idle again.
                        The initial location is then a stable location, as the component is idle.
                        In the other locations, the component is not stable, as it is busy performing its task.
                        Another example is for instance a motor that can be turned on or off.
                        A motor could be stable and safe when it is off, as it then doesn't drive any movements in the system, keeping the system in a stable state.
                        Such a motor could then be modeled as an automaton with two locations, one where the motor is on, and one where the motor is off.
                        The location where the motor is off, would be its initial and marked location, as that is where the motor is stable.
                    </p>
                    <p>
                        There are situations where the initial location should not be a marked location.
                        For instance, if a component should first be calibrated or otherwise prepared before it can perform its task.
                        The location after the calibration, where the component can repeatedly perform its task, would then be a better choice for a marked location.
                        In such a marked location, the component is calibrated, awaiting to perform its task.
                        And when the task is completed, it returns to its calibrated state, represented by the marked location.
                    </p>
                    <p>
                        Marked locations are also important when synthesizing a supervisor.
                        The synthesis procedure makes sure that there is always a sequence of events that leads back to a state where each automaton is in its marked location.
                        Marked locations can therefore be viewed as safe havens to which the system must be able to return.
                        For instance, the coffee machine should be able to return to its <code>Waiting</code> state, regardless of whether it is <code>Preparing</code>, <code>MakingCoffee</code> or <code>Finished</code> finished state.
                        The <code>Waiting</code> location is a safe haven that should be reachable from every location.
                    </p>
                    <p>
                        In the example of the bridge deck and traffic light, unsafe states <code>PartiallyOpenGreen</code> and <code>OpenGreen</code> should not be marked.
                        States <code>OpenRed</code>, <code>PartiallyOpenRed</code>, <code>ClosedRed</code> and <code>ClosedGreen</code> are all safe states and could be considered for marking.
                        One could consider a partially opened bridge deck to be less stable than a fully open or fully closed bridge deck.
                        And a traffic light that signals red keeps the system more stable than a traffic light that signals green, as a red signal does not allow cars to pass over the bridge.
                    </p>
                    <p>
                        Graphically, a marked location is represented as a circle with a double border.
                        We come back to marking and its role in synthesis in Module 3.
                    </p>
                    <p>
                        In automata with both locations and variables, a marked state is a state where the current location of the automaton is a marked location and the current value of each variable is a marked value.
                        Often, variable value marking is left implicit, such that all values of a variable are marked values.
                        But, it is also possible to mark specific variable values.
                        Similar to specifying an initial variable value by a predicate such as <code>ship_count = 0</code>, we may also use a marking condition to indicate under which conditions a variable is marked.
                        For instance, we may indicate that a variable <code>x</code> is marked whether it has a value that is at least three, by using marker predicate <code>x &gt;= 3</code>.
                    </p>

                    <h2>Quiz</h2>
                    <div class="quiz">
                        [
                            {
                                type: 'multiple-choice',
                                question: "Which of the following statements about the main concepts of automata are correct?",
                                answers: [
                                    "Locations and variables represent the possible states of a component, and by extension of a system.",
                                    "Locations (together with variables) represent the transitions from one states to another.",
                                    "Events are associated with the states of the system.",
                                    "Edges labeled with events represent possible transitions from one state to another.",
                                ],
                                correctAnswer: '1, 4'
                            }, {
                                type: 'single-choice',
                                question: "Which of the following statements about graphical representations of automata is correct?",
                                answers: [
                                    "States are represented as circles, transitions as arrows.",
                                    "States are represented as circles, edges as arrows.",
                                    "States are represented as arrows, transitions as circles.",
                                    "States are represented as arrows, edges as circles.",
                                    "Locations are represented as circles, transitions as arrows.",
                                    "Locations are represented as circles, edges as arrows.",
                                    "Locations are represented as arrows, transitions as circles.",
                                    "Locations are represented as arrows, edges as circles."
                                ],
                                correctAnswer: '6'
                            },
                            {
                                type: 'single-choice',
                                question: "What is the best description of a guard?",
                                answers: [
                                    "A condition that must hold for an edge to be taken.",
                                    "A protection mechanism for supervisors to prevent unsafe states.",
                                    "A person regulating unsafe entry to and exit from a system."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: "What is the best description of an update?",
                                answers: [
                                    "A modification of a component to make it represent the system's newest version.",
                                    "An addition of an extra location to an automaton.",
                                    "Assignments that update values of variables when an edge is taken."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'single-choice',
                                question: "Is it true that a variable can only change value as a consequence of an edge being taken?",
                                answers: [
                                    "Yes.",
                                    "No."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: "Can variables represent states of a system?",
                                answers: [
                                    "Yes: look at the ship counter example, where the value of the variable <code>ship_count</code> represents the number of ships in the water lock, which is part of the system's state.",
                                    "No: it is never possible that a variable represents the system's state, as locations are meant for this, and in the ship counter example the location with the self loop edges is the system's state."
                                ],
                                correctAnswer: '1'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    A motor that can be on or off can be modeled as an automaton with boolean variables that can be either <code>true</code> or <code>false</code>.
                                    Which of the following is the best automaton model for this component?`,
                                answers: [
                                    `Variables: <code>off</code>, <code>on</code>.<br>
                                     Edge 1 has guard <code>off = true</code>, event <code>turn_on</code> and update <code>off := false</code>.<br>
                                     Edge 2 has guard <code>on = true</code>, event <code>turn_off</code> and update <code>on := false</code>.`,
                                    `Variables: <code>off</code>, <code>on</code>.<br>
                                     Edge 1 has guard <code>off = true</code>, event <code>turn_on</code> and update <code>on := true</code>.<br>
                                     Edge 2 has guard <code>on = true</code>, event <code>turn_off</code> and update <code>off := true</code>.`,
                                    `Variables: <code>off</code>, <code>on</code>.<br>
                                     Edge 1 has guard <code>on = false</code>, event <code>turn_on</code> and update <code>off := false</code>.<br>
                                     Edge 2 has guard <code>off = false</code>, event <code>turn_off</code> and update <code>on := false</code>.`,
                                    `Variables: <code>off</code>, <code>on</code>.<br>
                                     Edge 1 has guard <code>on = false</code>, event <code>turn_on</code> and update <code>on := true</code>.<br>
                                     Edge 2 has guard <code>off = false</code>, event <code>turn_off</code> and update <code>off := true</code>.`,
                                    `Variables: <code>on</code>.<br>
                                     Edge 1 has guard <code>on = true</code>, event <code>turn_on</code> and update <code>on := true</code>.<br>
                                     Edge 2 has guard <code>on = false</code>, event <code>turn_off</code> and update <code>on := false</code>.`,
                                    `Variables: <code>on</code>.<br>
                                     Edge 1 has guard <code>on = true</code>, event <code>turn_on</code> and update <code>on := false</code>.<br>
                                     Edge 2 has guard <code>on = false</code>, event <code>turn_off</code> and update <code>on := false</code>.`,
                                    `Variables: <code>on</code>.<br>
                                     Edge 1 has guard <code>on = false</code>, event <code>turn_on</code> and update <code>on := true</code>.<br>
                                     Edge 2 has guard <code>on = true</code>, event <code>turn_off</code> and update <code>on := false</code>.`,
                                    `Variables: <code>on</code>.<br>
                                     Edge 1 has guard <code>on = false</code>, event <code>turn_on</code> and update <code>on := false</code>.<br>
                                     Edge 2 has guard <code>on = true</code>, event <code>turn_off</code> and update <code>on := true</code>.`
                                ],
                                correctAnswer: '7'
                            },
                            {
                                type: 'single-choice',
                                question: "What is the best definition of a marked location?",
                                answers: [
                                    "It is a location that is indicated with a mark by the systems designer.",
                                    "It is a location which the modeler of the system considers to be stable.",
                                    "It is the location at which the automaton starts."
                                ],
                                correctAnswer: '2'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    We have an automaton <code>Toggle</code> that consists of the locations <code>On</code> and <code>Off</code>, representing a system that can be on or off.
                                    Which location would you consider to be a marked location?`,
                                answers: [
                                    "<code>On</code>, because you want your system to be on to be productive.",
                                    "<code>Off</code>, because your system is safe and stable when it is off.",
                                    "It depends on the system, as some systems have a stable <code>On</code> state and others a stable <code>Off</code> state."
                                ],
                                correctAnswer: '3'
                            },
                            {
                                type: 'multiple-choice',
                                question: "Which of the following concepts can be used to model an automaton?",
                                answers: [
                                    "Edges.",
                                    "Events.",
                                    "Guards.",
                                    "Initial events.",
                                    "Initial locations.",
                                    "Marked locations.",
                                    "Marked variable values.",
                                    "Locations.",
                                    "States.",
                                    "Transitions.",
                                    "Updates.",
                                    "Variables.",
                                ],
                                correctAnswer: '1, 2, 3, 5, 6, 7, 8, 11, 12'
                            },
                            {
                                type: 'single-choice',
                                question: `
                                    The <code>Toggle</code> automaton from a previous question has initial location <code>Off</code>, and events <code>go_on</code> and <code>go_off</code>.
                                    Furthermore, the automaton counts how often the system has been turned on, with the variable <code>count</code> that is initially zero.
                                    The system is allowed to be turned on maximally five times for safety reasons.
                                    The modeler of the system declared the <code>Off</code> location to be marked.
                                    What is a correct automaton model for the component?`,
                                answers: [
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>On</code>.
                                     Initial values: <code>On = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &gt; 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &gt;= 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and update <code>count := count - 1</code>.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>On</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 5</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt;= 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>On</code>.
                                     Initial values: <code>On = 5</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt; 5</code>, event <code>go_on</code> and update <code>count := count - 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt; 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt;= 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt; 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and update <code>count := count - 1</code>.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 5</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &lt;= 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>Off</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &gt; 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and update <code>count := count - 1</code>.`,
                                    `Locations: <code>On</code>, <code>Off</code>.
                                     Initial locations: <code>Off</code>.
                                     Marked locations: <code>On</code>.<br>
                                     Variables: <code>count</code>.
                                     Initial values: <code>count = 0</code>.
                                     Events: <code>go_on</code>, <code>go_off</code>.<br>
                                     Edge 1 from location <code>Off</code> to location <code>On</code> has guard <code>count &gt; 5</code>, event <code>go_on</code> and update <code>count := count + 1</code>.<br>
                                     Edge 2 from location <code>On</code> to location <code>Off</code> has guard <code>true</code>, event <code>go_off</code> and no update.`
                                ],
                                correctAnswer: '5'
                            }
                        ];
                    </div>

                    <div class="course-navigation-footer">
                        <div class="course-navigation-prev"><a href="discrete-event-systems.html">Go back to Module 1.2</a></div>
                        <div class="course-navigation-separator">|</div>
                        <div class="course-navigation-next"><a href="get-started-with-cif.html">Proceed to Module 1.4</a></div>
                    </div>

                </div>
            </div>
        </div>

        <!-- Footer -->
        <div class="container" id="footer">
            <footer class="pt-3 mt-4">
                <ul class="nav justify-content-center border-top pb-1 mb-1">
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org">Eclipse Home</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/privacy.php">Eclipse Privacy Policy</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/termsofuse.php">Eclipse Terms of Use</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal/copyright.php">Eclipse Copyright Agent</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.org/legal">Eclipse Legal</a></li>
                    <li class="nav-link disabled text-muted">|</li>
                    <li class="nav-item"><a class="nav-link px-2 text-muted" href="https://eclipse.dev/escet/legal.html">Eclipse ESCET Legal</a></li>
                </ul>
                <p class="text-center text-muted">Copyright © 2010, 2025 Contributors to the Eclipse Foundation</p>
            </footer>
        </div>

    </body>
</html>
